Subject: Re: Extension path and fuzzy sets

From: Graham Klyne <[email-masked]>
Date: Sat, 31 Oct 1998 09:44:08 +0000

At 09:27 30/10/98 -0500, Al Gilman wrote:
>> The algebraic framework, as defined, is purely Boolean/non-fuzzy.  Its
>> purpose is to identify the set of _all_ possible feature collection
>> candidates for a message transfer.
>
>The algebraic framework, as initially defined, contains only the
>Boolean class.  Is it intended to be extensible?  I would have
>said that "to identify the set of _all_ possible feature
>collection candidates for a message transfer" is its _initial
>capability_, not its ultimate purpose.  

I had not considered extension to non-Boolean "predicate" funtions.

I have not treated such extension as a requirement of the work.  On the
other hand, if the framework lends itself to extension then I see no reason
to prohibit consideration of such.

>Its purpose is -- what?

My goal here was relatively modest...

>  To describe information derivation
>patterns?  Patterns of information relationship?  To declare
>knowledge fragments that can be combined into an automated
>process of shrinking choice ambiguity.

... simply to identify the possible features for message transfer, and to
provide a raw means to indicate some kind of preference.  To take it
further would overstretch my mathematical abilities and, I believe, add
unhelpful complexity to a system that already is perceived as complex.

>...  In this sense, the
>assertion of a q-value shares this mission with the assertion of
>boolean combiners.

I would say the paramaterization mechanism (including q-values) is a means
of incorporating additional "knowledge fragments", in advance of knowing
how such fragments might be used.

>One of the purposes of an algebra is for different relationships
>to be added into the negotiation process from different sources.
>Not just the information source and sink players of the eventual
>transfer, but protocol and resource technology definitions, and
>standard operating procedure conventions within small
>communities.

Certainly, application of constraints imposed by different entities in a
message transfer process was one of my goals.

>Let's leave the question as to whether q=0 is better or worse than
><option not mentioned> to explicit statements.  Unless I am told,
>I don't know how an implementer of the framework will handle this.

Fine -- I was just trying to be precise about the framework as it stands.

>> I believe that there is a posible isomorphism between the -syntax-
>> framework with additional q-value combining rules, and a fuzzy-set
>> extension mechanism, ...
>
>To the extent that I understand fuzzy logic, this is exactly in
>agreement with what I understand.

Good.

>Detail note: binding 0 to FALSE is optional in the above scenario.  It
>works either way.

Fine:  I hadn't thought beyond the implication previously mentioned.

>...  To me, saying
>that the q-values are completely distinct from number classes in
>other applications is misleading or at least wasteful.  Wasteful
>because the information lost has possible usefulness.  To say
>that they are always applied independently of any numbers that
>may appear in feature definitions and predicates is unduly
>restrictive of function.

I think I understand where you coming from.  I deliberately said that this
applies "in general", meaning that an association between numeric feature
values and q-values was never _required_.  I can envisage situations in
which it might be useful to define q-values as functions of some numeric
(or non-numeric feature value).  But that would be structly part of a
q-value extension, and not a property of the algebraic framework as it stands.

>The hypothesis that I am working from is that reasonable
>combining rules for q-values can be viewed as algebraic (whith
>fuzzy logic an example) for the right definition of a topology on
>these values.  Ordinals have a different topology from cardinals.
>But they have a topology.  And it is the topology of preference
>that the conventions using [0...1] and selected operators needs
>to capture.
>
>This suggests that we can absorb the q-factor-combining and
>final-choice-selection steps into an the algebraic or value-flow
>framework shared with the existing boolean algebra, once more
>pieces of the definition have been put in place.
>
>They are disconnected now, but they are not disconnected for any
>valid purpose.  The eventual integration into a single functional
>flow with user-registered reductions applied as a matter of
>course is desirable to keep alive as a possible outcome.

As an area for future research and experimentation, indeed.

>The issue of negotiation, of reconciling policy profiles to
>arrive at a deal, is all over the place these days.

This is something that motivated me in this work.  I wanted to provide some
kind of formal (=> reliable, consistent) framework for handling these
affairs across a range of environments.  It doesn't solve all conceivable
requirements, but I do believe a rigorous and symbolic (algebraic) approach
provide a solid basis for further development.

>It's true that if it isn't simple, implementors won't implement
>it; but if it doesn't fit into the global flow users won't use
>it, very long.  Something better will roll right over it.

I think I understand, and agree.  And I view the tabled proposals as a
stride of appropriate length in the right direction.

#g

------------
Graham Klyne
([email-masked])

---

From: Al Gilman <[email-masked]>
Date: Sat, 31 Oct 1998 09:00:10 -0500 (EST)

Thank you very much for your thoughtful reading of my ramblings.

to follow up on what Graham Klyne said:

[Purpose of the MEDFREE framework]

> unhelpful complexity to a system that already is perceived as complex.

This is perhaps what Koen was talking about.  There are some
guiding principles for the system which can keep it simple as it
grows.  It may be our failure to clearly articulate them that
makes extension look like growth in complexity.  If we get the
basic pattern within which we are elaborating the technology
articulated, then we may have a prayer of keeping what we have
produced simple over the long term, and removing some of the
perceived complexity as it stands now.

The model I am working from is a "two-point boundary value
problem" analogy.  One fixed boundary point is the notion of
resource entities, the other fixed boundary point is the notion
of a choice [of a course of action].  There are two fundamental
activities in the overall process: characterizing the resource
entities by associating properties with them, and making choices
by operating on the asserted properties of the visible resources.

What is growing is the richness of vocabulary used in the middle
of this process.  The start point: a resource is an entity, and
the end point: a resolution is a choice, are not changing.  But
as we add primitives and structures to how we characterize the
entities, we should also allow for the addition of functions that
can be used as we extract choices from complex characterizations.
It _can_ all be done in Boolean forms, but we are at risk of
requiring very _compound_ assertions in the meta-dialog if we
don't allow the use of _complex_ operators in the statement of
policies.

One source of simplicity is the entity/attribute calculus by
which we build from the initial point.  Another source of
simplicity is the functional decomposition calculus by which we
refine the endgame.  We should be employing both of these
simplifying resources to contain that demon complexity.

Al